<?php
/* 
* vmfiltering component
* @version $Id: categories.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage models
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/


jimport( 'joomla.application.component.model' );

/**
 * @package Joomla
 * @subpackage Config
 */
class VmfModelCategories extends JModel
{ 
  var $_total = null;  
  /**
   * Pagination object
   * @var object
   */
  var $_pagination = null;
  var $where=null;
  
function __construct()
{
	parent::__construct();
	global $mainframe, $option;
	

	// Get the pagination request variables
	$limit = null;
	$limitstart = null;	
	$this->VM_cat= $mainframe->getUserStateFromRequest ( 'com_vmFiltering.vmCat','vmCat','','int' );
		
	if ($this->VM_cat){
	$this->where=' AND vm_vmf.vm_cat='.$this->VM_cat;
	}
}


function _buildQuery()
    {
        $query = ' SELECT DISTINCT #__vmfilteringcat.* '
            . ' FROM #__vm_category,#__vmfilteringcat INNER JOIN #__vmfcat_vmcat_xref AS vm_vmf ON #__vmfilteringcat.id=vm_vmf.vmf_cat WHERE vm_vmf.vm_cat=#__vm_category.category_id'.$this->where.' ORDER BY  #__vmfilteringcat.ordering'
        ;
        return $query;
    }

    /**
     * Retrieves the data
     * @return array Array of objects containing the data from the database
     */
    function &getData()
    {
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query );
			}
        return $this->_data;
	   }

function getPagination()
{
	$data=$this->getData();
	$total=count($data);
	
	
	// Lets load the content if it doesnt already exist
	if (empty($this->_pagination))
	{
		jimport('joomla.html.pagination');
		$this->_pagination = new JPagination( $total, $this->getState('limitstart'), $this->getState('limit') );
	}
	
	return $this->_pagination;
}

function getVmCatsParents(){//get the VM categories hierarchy
	$blank="";
	$blanks=array();
	$db=JFactory::getDBO();
	$query="SELECT category_parent_id AS p_id ,category_child_id AS id FROM #__vm_category_xref ORDER BY category_child_id";
	$db->setQuery($query);
	$results=$db->loadObjectList ();	
	
	$blanks[0]='';
	
	if(count($results)>0){
	foreach($results as $res){	
	$blanks[$res->id]=$blanks[$res->p_id];
	$blanks[$res->id].=str_pad($blank, 6,"&nbsp;", STR_PAD_RIGHT);
	
	}
	}
	
	return $blanks;
}

function getVmCats(){//get the VM categories names
	$db=JFactory::getDBO();
	$query="SELECT category_id AS value ,category_name AS text FROM #__vm_category JOIN #__vmfcat_vmcat_xref ON category_id=vm_cat GROUP BY vm_cat";
	$db->setQuery($query);
	$results=$db->loadObjectList();
	
	return $results;	
}

function getViewList(){//returns a generic list of vm categories
	global $mainframe, $option;
	$lists=array();	
	$VmCats=$this->getVmCats();	
	
	$space=$this->getVmCatsParents();
	$blank_field[]=JHTML::_('select.option','0', "Select VM Category");		 
	
	if(count($VmCats)>0){
		foreach($VmCats as $vm){
			//give values to the select option 	
			$text=$space[$vm->value].$vm->text;
			$lists[]= JHTML::_('select.option', $vm->value, $text);	
		}			
	}
	else { 
			$db=JFactory::getDBO();
			$query="SELECT COUNT(category_id) AS count FROM #__vm_category ";
			$db->setQuery($query);
			
			if(!$db->query()){//CHECK FOR ERRORS
			$this->setError($db->getErrorMsg());
		}
				
			$result=$db->loadResult();
				
				if($result<=0){
				
				?> 
                 <div id="system-message" style="width:100%;">
                 <?php echo JText::_('The VirtueMart Component hasn\'t got Categories. Create Categories into VM First');?></div><?php	}
			}
	 
	$lists=array_merge($blank_field,$lists);
	
	 if ($this->VM_cat){//decide the value thats being viewed
	 $selected=$this->VM_cat;
	 //JRequest::setVar('vm_cat',$this->VM_cat);
	 }
	 else $selected=$blank_field;
	 
	$input=JHTML::_('select.genericlist',$lists,'vmCat','class="inpubox" size="1" onchange="submitform();"','value','text',$selected);//creates the select tag	
	
	 return $input;
	}
		
		
		
function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );		
		$db=&$this->getDBO();
		
		   
	$row =& $this->getTable('category');
		if (count( $cids )>0)
		{
			foreach($cids as $cid) {
			
			//delete the prodsubcats records that connects to the subcast that connects to the cats
			$query='DELETE FROM #__vmfprodsubcategory'.
				' WHERE ids IN (SELECT ids FROM #__vmfilteringsubcat WHERE vmfCatId = '.$cid.")";
				$db->setQuery($query);
				if(!$db->query()){
				$this->setError($db->getErrorMsg());
				return;
				}
			
			
			//delete the subcats that connects to the cats
				$query='DELETE FROM #__vmfilteringsubcat'.
				' WHERE vmfCatId = '.$cid;
				$db->setQuery($query);
				
				if(!$db->query()){
				$this->setError($db->getErrorMsg());
				return;
				}
			
				//delete categories xref vmfcat
				$query='DELETE FROM #__vmfcat_vmcat_xref'.
				' WHERE vmf_cat = '.$cid;
				$db->setQuery($query);
				
				if(!$db->query()){
				$this->setError($db->getErrorMsg());
				return;
				}
				
				
				
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
				
			}						
		}
		return true;
	}
	

function setItemState( $items, $state )
	{
		if(is_array($items))
		{
			$row =& $this->getTable('Category');
			foreach ($items as $id)
			{
				$row->load( $id );				
					$row->published = $state;
					if (!$row->check()) 
					{
						$this->setError($row->getError());
						return false;
					}
					if (!$row->store()) 
					{
						$this->setError($row->getError());
						return false;
					}
			} 		
		}		
		return true;
	}

function orderItem($id, $movement)
	{
		$row =& $this->getTable('Category');
		$row->load($id );
		$row->move( $movement);
	return true;
	}

	
	
function setOrder($items){
		$data=$this->getData();
		$total=count($data);
		$row		=& $this->getTable('Category');
		
		$order		= JRequest::getVar( 'ordering', array(), 'post', 'array' );
	
		JArrayHelper::toInteger($order);
		// eliminate duplicate values
		for( $i=0; $i < $total; $i++ ) {
		  for( $j=$total; $j >$i; $j-- ) {
		  	if($order[$i]==$order[$j]){
				$order[$j]+=1;
					}
				}
			}
			
			for( $i=0; $i < $total; $i++ ) {			
			$row->load( $items[$i] );
			// track parents
			if ($row->ordering != $order[$i]) {
			
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($row->getError());
					return false;
				}// if
			} // if
		} // for
		return $order[0];
	}

}
?>