<?php
/* 
* vmfiltering component
* @version $Id: category.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage models
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/


defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.application.component.model' );

/**
 * @package Joomla
 * @subpackage Config
 */
class VmfModelCategory extends JModel
{

function __construct()
{
    parent::__construct(); 
    $array = JRequest::getVar('cid',  0, '', 'array');
    $this->setId((int)$array[0]);
}


function setId($id)
{
    // Set id and wipe data
    $this->_id= $id;
	$this->result=null;
	//echo $this->_id;
 }


function getData()
    {	
	
	  $db=& JFactory::getDBO();

      $query = ' SELECT * FROM #__vmfilteringcat WHERE id= '.$this->_id;
		
	 $db->setQuery( $query );
     $this->result=$db->loadObject();	
     return $this->result;	
    }

    /**
     * Retrieves the hello data
     * @return array Array of objects containing the data from the database
     */
 
 function getMaxOrder()
    {	
	$db=&JFactory::getDBO();
	
	$query=' SELECT MAX(ordering) FROM #__vmfilteringcat ';
	$db->setQuery($query);
	$this->result=$db->loadResult();	  
	return $this->result;
    }
	
function getMaxCatId()
    {	
	$db=&JFactory::getDBO();
	
	$query=' SELECT MAX(id) FROM #__vmfilteringcat';
	$db->setQuery($query);
	$this->result=$db->loadResult();	  
	return $this->result;
    }
	
	
//returns the max ordering value of the current subCategory
function getMaxSubOrdering($catid){
	$db=&JFactory::getDBO();
	$query=' SELECT MAX(ordering) FROM #__vmfilteringsubcat WHERE vmfCatId='.$catid;
	$db->setQuery($query);
	$this->result=$db->loadResult();	  
	return $this->result;
}

function getVmCatsParents(){//get the VM categories names
	$blank=".";
	$blanks=array();
	$db=JFactory::getDBO();
	$query="SELECT category_parent_id AS p_id ,category_child_id AS id FROM #__vm_category_xref ORDER BY category_child_id";
	$db->setQuery($query);
	$results=$db->loadObjectList ();
	
	
	$blanks[0]='';
	
	foreach($results as $res){	
	$blanks[$res->id]=$blanks[$res->p_id];
	$blanks[$res->id].=str_pad($blank, 6," ", STR_PAD_RIGHT);	
	}	
	return $blanks;
}


function store(){
	//vars initilization
	$row =& $this->getTable();
	$data = JRequest::get( 'post' );
	$ids=JRequest::getVar('ids', array(), 'post', 'array');
	$names=JRequest::getVar('nameS', array(), 'post', 'array');
	$vm_cats=JRequest::getVar('vm_cat', array(), 'post', 'array');
	$db=JFactory::getDBO();
    $categories=array();
	
	print_r($names);
	JArrayHelper::toInteger($ids);
 

    // Bind the form fields to the vmfiltering_cat table
    if (!$row->bind($data)) {
        $this->setError($this->_db->getErrorMsg());
        return 'Error binding';
    }
 
    // Make sure the vmfiltering_cat record is valid
    if (!$row->check()) {
        $this->setError($this->_db->getErrorMsg());
        return 'Error checking';
    }
 
    // Store the web link table to the database
    if (!$row->store()) {
        $this->setError($this->_db->getErrorMsg());
        return 'Error storing';
    }
	

	//check if the feature is new //has id

	if($data['id']){
	    $vmfCatId=$data['id'];
        $q="SELECT vm_cat FROM #__vmfcat_vmcat_xref WHERE vmf_cat=".$data['id'];
        $db->setQuery($q);
        $categories=$db->loadResultArray();
        //return implode(',',$categories);
        $toBeDeleted=array_diff($categories,$vm_cats);

        if(!empty($toBeDeleted)){
          //delete the records with previous categories
    		$query="DELETE FROM #__vmfcat_vmcat_xref WHERE vmf_cat=".$data['id']." AND vm_cat IN(".implode(',',$toBeDeleted).")";
    		$db->setQuery($query);
    		if(!$db->query()){
    			$this->setError($this->_db->getErrorMsg());
            	return 'Error deleting previous vm categories'.$this->_db->getErrorMsg();
    		}
             //delete the assigned products from previous categories
            $query2="DELETE prod_f FROM (#__vmfprodsubcategory AS prod_f INNER JOIN #__vmfilteringsubcat AS feat ON feat.ids=prod_f.ids) ";
            $query2.="INNER JOIN #__vm_product_category_xref AS p_cat ON p_cat.product_id=prod_f.product_id WHERE p_cat.category_id IN(".implode(',',$toBeDeleted).") ";
            $query2.="AND feat.vmfCatId=".$data['id'];
            //RETURN ($query2);
            $db->setQuery($query2);
    		if(!$db->query()){
    			$this->setError($this->_db->getErrorMsg());
            	return 'Error deleting previous vm categories'.$this->_db->getErrorMsg();
    		}
        }
	}
    else{
	    $vmfCatId=$this->getMaxCatId();
	}
   $toBeInserted=array_diff($vm_cats,$categories);

    if(!empty($toBeInserted)){
    	foreach($toBeInserted as $vm_cat){
    			$query="INSERT INTO #__vmfcat_vmcat_xref (vm_cat, vmf_cat) VALUES (".$vm_cat.",".$vmfCatId.")";
    		$db->setQuery($query);

    		if(!$db->query()){
    			$this->setError($this->_db->getErrorMsg());
            	return 'Error inserting new vm categories'.$this->_db->getErrorMsg();
    		}
    	}
    }
	//--------stores the Subcategories-Features------------------//
	require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables'.DS.'subcategories.php');
	$rowsub=& $this->getTable('subCategories');
	
	for($j=0; $j<count($names); $j++){
	
	 if($ids[$j]){ //check if is there is the subCat
	 	$rowsub->load($ids[$j]);
 
		if ($rowsub->nameS != $names[$j]){//update existing
			
			$rowsub->nameS=$names[$j];		//update	
			$rowsub->vmfCatId=$vmfCatId; //the vmCat id
			
			}//if
	 }//if		
		
	else{//is new subcat
		$order=$this->getMaxSubOrdering($vmfCatId);
		$order+=1; //give the next id
	 	$rowsub->ids=NULL;
	 	$rowsub->vmfCatId=$vmfCatId;
		$rowsub->nameS=$names[$j];
		$rowsub->ordering=$order;
		}//else	
  
  	if (!$rowsub->store()) {
			$this->setError($rowsub->getError());
			return 'Error storing subcategory';
		}// if 	
      
 }//for

    return true;
}

function getSubCats()	{
	$db=JFactory::getDBO();
	$query="SELECT * FROM #__vmfilteringsubcat WHERE vmfCatId= ".$this->_id ." ORDER BY ids ASC";
	$db->setQuery($query);
	$this->result = $db->loadObjectList ();
	return $this->result;
}

	

}

?>