<?php
/*
* vmfiltering component
* @version $Id: subcategories.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage models
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/


jimport( 'joomla.application.component.model' );

/**
 * @package Joomla
 * @subpackage Config
 */
class VmfModelSubCategories extends JModel
{


function __construct()
{
	parent::__construct();

	$this->VM_cat=null;
	global $mainframe, $option;

    //$this->VM_cat=JRequest::getVar('vm_cat');
	$this->VM_cat= $mainframe->getUserStateFromRequest( 'com_vmFiltering.vm_cat','vm_cat','','int' );
    if(@$_SESSION['vm_cat_sel']!=$this->VM_cat){
       $_SESSION['vmf_limit']=$mainframe->getCfg('list_limit');
       $_SESSION['vmf_limitstart']=0;
       $_SESSION['vm_cat_sel']=$this->VM_cat;
    }else{
  	// Get the pagination request variables
      //limit

      $limit=JRequest::getVar('limit', -5, '', 'int');
      if($limit!=-5){
        $_SESSION['vmf_limit']=$limit;
      }else if($limit==-5 && !isset($_SESSION['vmf_limit'])){
          $_SESSION['vmf_limit']=$mainframe->getCfg('list_limit');
      }



      //limitstart
      $limitstart = JRequest::getVar('limitstart', -5, '', 'int');

      if($limitstart!=-5){
          $_SESSION['vmf_limitstart']=$limitstart;
      }else if($limitstart==-5 && !isset($_SESSION['vmf_limitstart'])){
          $_SESSION['vmf_limitstart']=0;
      }

    }
    $vmf_limitstart=$_SESSION['vmf_limitstart'];
    $vmf_limit=$_SESSION['vmf_limit'];
    $vmf_limitstart = ($vmf_limit != 0 ? (floor($vmf_limitstart / $vmf_limit) * $vmf_limit) : 0);

	$this->setState('limit', $vmf_limit); // Set the limit variable for query later on
	$this->setState('limitstart', $vmf_limitstart);

}



function _buildQuery()
    {
     global $mainframe;

    $where=array();
    $wq='';

    //cat ids of VM product
    $cat_ids=JRequest::getVar('cat_ids',array(),'get','array');
    //print_r($cat_ids);
	if ($this->VM_cat){
	    $where[0]='vmf_vm_xref.vm_cat='.$this->VM_cat;
	}

    if($cat_ids){
     $where[0]='vmf_vm_xref.vm_cat IN('.implode(',',$cat_ids).")";
    }
    if($where) $wq=" WHERE ".implode(' AND ',$where);

	/* $query = ' SELECT #__vmfilteringsubcat.ids, #__vmfilteringsubcat.vmfCatId,  #__vmfilteringsubcat.nameS,  #__vmfilteringsubcat.published,  #__vmfilteringsubcat.ordering  '
            . ' FROM #__vmfilteringsubcat ,#__vmfilteringcat, #__vm_category  WHERE  #__vmfilteringsubcat.vmfCatId=#__vmfilteringcat.id  AND #__vmfilteringcat.vm_cat=#__vm_category.category_id AND #__vmfilteringcat.vm_cat='.$this->VM_cat.' ORDER BY #__vmfilteringsubcat.vmfCatId, #__vmfilteringsubcat.ordering';*/

	 $query = 'SELECT DISTINCT vmfsubcat.ids, vmfsubcat.vmfCatId,  vmfsubcat.nameS,  vmfsubcat.published,  vmfsubcat.ordering '
            . ' FROM #__vmfilteringsubcat AS vmfsubcat INNER JOIN #__vmfilteringcat AS vmfcat ON vmfsubcat.vmfCatId=vmfcat.id INNER JOIN #__vmfcat_vmcat_xref AS vmf_vm_xref ON
			vmfcat.id=vmf_vm_xref.vmf_cat'.$wq.' ORDER BY vmfsubcat.vmfCatId, vmfsubcat.ordering';

	 //print_r($query);
     return $query;
	 }


 function &getData()
    {
      $tmpl=JRequest::getVar('tmpl','');
      if($tmpl && $tmpl=='component') {$limit=0; $limitstart=0; }
      else {$limit=$this->getState('limit'); $limitstart=$this->getState('limitstart');}
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query,$limitstart ,$limit);
			}
        return $this->_data;
	   }

 function getTotal()
  {
 	// Load the content if it doesn't already exist
 	if (empty($this->_total)) {
 	    $query = $this->_buildQuery();
 	    $this->_total = $this->_getListCount($query);
 	}
 	return $this->_total;
  }


function delSubs($id){
$row=& $this->getTable();

	if(!$row->delete($id)){
		$this->setError($row->getError());
		return false;
	}

	return true;
}

function getVmCatsParents(){//create spaces according to the categories hierarchy
	$blank="";
	$blanks=array();
	$db=JFactory::getDBO();
	$query="SELECT category_parent_id AS p_id ,category_child_id AS id FROM #__vm_category_xref ORDER BY category_child_id";
	$db->setQuery($query);
	$results=$db->loadObjectList ();

	$blanks[0]='';

	if(count($results)>0){
	foreach($results as $res){
	$blanks[$res->id]=$blanks[$res->p_id];
	$blanks[$res->id].=str_pad($blank, 6,"&nbsp;", STR_PAD_RIGHT);
	}
	}

	return $blanks;
}

function getVmCats(){//get the VM categories names
	$db=JFactory::getDBO();
	$query="SELECT category_id AS value ,category_name AS text FROM #__vm_category AS vm_cat JOIN #__vmfcat_vmcat_xref AS vmfcat_vmcat ON vm_cat.category_id=vmfcat_vmcat.vm_cat GROUP BY vm_cat";
	$db->setQuery($query);
	$results=$db->loadObjectList ();

	return $results;


}

function getViewList(){//returns a generic list of vm categories
	global $mainframe, $option;
	$VmCats=$this->getVmCats();
	$lists=array();

	$space=$this->getVmCatsParents();
	$blank_field[]=JHTML::_('select.option','0', "Select VM Category");

	if(count($VmCats)>0){
		foreach($VmCats as $vm){
		//give values to the select option
		$text=$space[$vm->value].$vm->text;
		$lists[]= JHTML::_('select.option', $vm->value, $text);
		 }

	 }else {$db=JFactory::getDBO();
				$query="SELECT COUNT(category_id) AS count FROM #__vm_category ";
				$db->setQuery($query);

				if(!$db->query()){//CHECK FOR ERRORS
				$this->setError($db->getErrorMsg());
				}

				$result=$db->loadResult();

				if($result<=0){

				?>
                 <div id="system-message" style="width:100%;">
                 <?php echo JText::_('The VirtueMart Component hasn\'t got Categories. Create Categories into VM First');?></div><?php	}
			}


	$lists=array_merge($blank_field,$lists);

	 if ($this->VM_cat){//decide the value thats being viewed
	 $selected=$this->VM_cat;
	 //JRequest::setVar('vm_cat',$this->VM_cat);
	 }
	 else $selected=$blank_field;

	$input=JHTML::_('select.genericlist',$lists,'vm_cat','class="inpubox" size="1" onchange="submitform();"','value','text',$selected);//creates the select tag


	 return $input;
	}



function getPagination()
{   global $mainframe;
    $total=$this->getTotal();
    $limitstart=$this->getState('limitstart');
    $limit=$this->getState('limit');


	// Lets load the content if it doesnt already exist
	if (empty($this->_pagination))
	{
		jimport('joomla.html.pagination');
		$this->_pagination = new JPagination($total,$limitstart, $limit );
	}

	return $this->_pagination;
}


function delete()
	{
	$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
	$db=&$this->getDBO();

	$row =& $this->getTable();

		if (count( $cids )>0)
		{
			foreach($cids as $cid) {

				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}

				//delete also the records that connects with the subcats from the table #__vmfprodsubcategory
				$query="DELETE FROM #__vmfprodsubcategory WHERE ids=".$cid;
				$db->setQuery($query);

				if(!$db->query()){//CHECK FOR ERRORS
				$this->setError($db->getErrorMsg());
				}
			}
		}
		return true;
	}


function setItemState( $items, $state )
	{
		if(is_array($items))
		{
			$row =& $this->getTable();
			foreach ($items as $id)
			{
				$row->load( $id );
					$row->published = $state;
					if (!$row->check())
					{
						$this->setError($row->getError());
						return false;
					}
					if (!$row->store()) 					{
						$this->setError($row->getError());
						return false;
					}
			}
		}
		return true;
	}

function orderItem($id, $movement)
	{
		$row =& $this->getTable();
		$row->load($id );
		$row->move( $movement);
	return true;
	}



function setOrder($items){
		$VmCats=$this->getVmCats();
		$totalCats=count($VmCats);
		$row=& $this->getTable();

		$order= JRequest::getVar( 'ordering', array(), 'post', 'array' );
		JArrayHelper::toInteger($order);
		$data=$this->getData();
		$totalRows=count($data);
		$cat=array();
		$value=$data[0]->vmfCatId;
		$k=0;

		/*for( $i=0; $i <$totalRows; $i++ ) {//creates arrays as much as the vmfCats
			if($value!=$data[$i]->vmfCatId) $k++;
		 	$cat[$k][]=$data[$i]->ids;
		  $value=$data[$i]->vmfCatId;
		}*/


		for( $i=0; $i <$totalRows; $i++ ) {//creates arrays as much as the vmfCats
			if($value!=$data[$i]->vmfCatId) {$k++;
		 	$cat[]=$i;}
		  $value=$data[$i]->vmfCatId;
		  }




		// eliminate duplicate values
		$arrayCount=count($cat);
		$start=0;

		for( $i=0; $i <$arrayCount-1; $i++ ) {
		$limit=$cat[$i];
		$limit-=1;

		  for( $j=$start; $j<$limit; $j++) {
		  	 for($p=$limit; $p >$j; $p--) {

		  		if($order[$p]==$order[$j]){
					$order[$p]+=1;
					$xaxa='yea';
					}
				}
			}
		$start=$limit+1;}

		//---------------store-----------------------//
			for( $i=0; $i <count($order); $i++ ) {
			$row->load( $items[$i] );
			// check changes
			if ($row->ordering != $order[$i]) {

				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($row->getError());
					return false;
				}// if
			} // if
		} // for
		return $limit;
	}
//-------used for VM hack----------//
function getProd_vmfFeat($prod_id){
	$reslt=array();
	$db=JFactory::getDBO();
	$query="SELECT ids FROM #__vmfprodsubcategory WHERE product_id=".$prod_id;
	$db->setQuery($query);
	$result=$db->loadResultArray  ();

	return $result;
}

}
?>

