<?php
/* 
* vmfiltering component
* @version $Id: vmf.php 1.5.14 4-May-2011 13:58:41Z sakisTerz $
* @package vmfiltering front-end
* @subpackage models
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
* fixed apply tax when weight and virtual tax disabled
* function that returns manufacturers added
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class VmfModelVmf extends JModel{


var $params;
var $result=NULL;
//the params from VM
var $show_prices=NULL;
var $tax_virtual=NULL;
var $tax_mode=NULL;
var $payment_discount_before=NULL;
var $flypage=NULL;
var $check_stock=NULL;

//data from shopper 
var $disc=NULL;
var $vat=NULL;
var $shopper_is_register=NULL;
var $shopper_country=NULL;
var $shopperGroupId=NULL;
var $defaulShopGroup=NULL;

//data from vendor
var $vendor=NULL;
var $style=NULL;
var $cur=NULL;
var $string=NULL;
var $vend_country=NULL;
var $vend_state=NULL;

var $usrTx=NULL;

//joomla configuration object
var $config=NULL;

//pagination vars
var $total=NULL; //the total products found used for the pagination
var $limit=NULL;
var $limitstart=NULL;

//search query vars
var $joinsExpr=array();
var $whereExpr=array();
var $orderExpr=NULL;



	function __construct()
	{
		$this->config=JFactory::getConfig();
		parent::__construct();
		global $mainframe, $option;
		$this->setVMparams();
		$this->params = &JComponentHelper::getParams( 'com_vmfiltering' );
	}

	function setVMparams(){//gets the vm params and sets them here
	
		global $show_prices,$tax_virtual,$tax_mode,$payment_discount_before;
		if(!defined('ADMINPATH')) define('ADMINPATH','administrator'.DS.'components'.DS.'com_virtuemart'.DS); //used from the fie components/virtuemart/virtuemart_parser.php line 74
		
		//require_once(ADMINPATH.'virtuemart.cfg.php'); //get the VM configuration file which has necessary params
		
		$filename=JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_virtuemart'.DS.'virtuemart.cfg.php';
		$contents=file_get_contents($filename);
		//fclose($handle);
		$contents=trim($contents);
		$contents=explode(';',$contents);
		
		foreach($contents as $cont){
			if(strpos($cont,"'_SHOW_PRICES'")) $show_prices=$cont[strlen($cont)-3];
			else if(strpos($cont,'TAX_VIRTUAL')) $tax_virtual=$cont[strlen($cont)-3];
			else if(strpos($cont,'TAX_MODE')) $tax_mode=$cont[strlen($cont)-3];
			else if(strpos($cont,'PAYMENT_DISCOUNT_BEFORE')) $payment_discount_before=$cont[strlen($cont)-3];
            else if(strpos($cont,'CHECK_STOCK')) $this->check_stock=$cont[strlen($cont)-3];
            else if(strpos($cont,'PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS')) $show_prd_out_of_stock=$cont[strlen($cont)-3];

            else if(strpos($cont,'VM_THEMEPATH')){
              $this->vm_theme=substr($cont,strpos($cont,'themes/')+strlen('themes/'),-4);
            }
			else if (strpos($cont,'FLYPAGE')) {
			$end=(int)strlen($cont)-2;
			$end=$end-20;
			$this->flypage=substr($cont,20,$end);
			}
		}

		if ($tax_mode==0){
			$this->usrTx=$this->getUserTax($_SESSION['auth']['user_id']);
		}
		$this->setShopperGroup_info();
	}
	
	
	function getVmfFeatures($ids){ //appears the subcats to the module

		global $mainframe;
        $val_exist=0; //indicates that there is at least 1 value
        $feat_val_exist=0; //indicates that the fearure has at least 1 value
		$join='';
		$id=implode(',',$ids);
        $feat_html='';
        $html='';
        $message='<p>&nbsp;'.JText::_('THERE ARE NO ASSIGNED FEATURES IN THIS CATEGORY').'&nbsp;</p>';

		/*
		 $module = &JModuleHelper::getModule('mod_vmFiltering');
		 $params=$module->print_rparams;
		 $parm=$params->get('prod_assigned');
		*/
		//the features with no products param from the module
		$featApp=JRequest::getVar('featApp','Y','get');

        $group=NULL;
		
		if (!$featApp){
			$join=' INNER JOIN #__vmfprodsubcategory AS prod_sub ON sub.ids=prod_sub.ids ';
			$group=' GROUP BY prod_sub.ids ';
		}

		//select the vmfCats
		$db=JFactory::getDBO();
		$query="SELECT DISTINCT id, name FROM #__vmfilteringcat INNER JOIN #__vmfcat_vmcat_xref AS vmfcat_vmcat ON #__vmfilteringcat.id=vmfcat_vmcat.vmf_cat WHERE vmfcat_vmcat.vm_cat IN(".$id.") AND published=1 ORDER BY ordering";
		$db->setQuery($query);
		$vmf_feat=$db->loadObjectList();
		
		if (count($vmf_feat)>0){
			$htmlAp='<div class="vmHeader"><div class="applybtn" onclick="dissapearFeat()"><span>'.JText::_('Apply').'</span></div></div>
			<div class="vmfWrapperInner">';
			//the same class names used for the label li and stong
			//this is done because js checks for specific class names clicked and decides to close or not the popup
			//it closes if the classNames are different that these declared

				foreach ($vmf_feat as $cat){
					$ft_html='<input type="hidden" name="feat_fl[]" value="'.$cat->id.'"/>
                    <ul class="featureList" id="'.$cat->name.'">';//create a UL list for each feature
					//use bin2hex to convert to hexademic
					//this used for non english languages where non ascii chars are not accepted for class names or ids
					$hexClassName=bin2hex($cat->name);
					$ft_html.='<li class="headerLi" id="'.$hexClassName.'Header">
					<label class="headerIn"><input type="checkbox" class="headerIn" onclick="checkAll(\''.$hexClassName.'\',\'feat\');">
					<strong class="headerIn">'.$cat->name.'</strong>
					</label></li>';//the header li

					$querry='SELECT * FROM #__vmfilteringsubcat AS sub '.$join.'WHERE published=1 AND vmfCatId='.$cat->id.''.$group.' ORDER BY ordering ';
					$db->setQuery($querry);
					$vmfSubs=$db->loadObjectList();
						
					//creates the sub li of the ul list-indicates features
                    if(count($vmfSubs)>0){
                        //$feat_val_exist=1;
                        $val_exist=1;
    					foreach($vmfSubs as $sub){
    					$ft_html.='
    						<li class="vmfsub"><label class="vmfsub"><input type="checkbox" class="'.$hexClassName.'" id="'.$sub->ids.'" name="feat_'.$cat->id.'[]" value="'.$sub->ids.'" title="'.$sub->nameS.'" onclick="setFeatInput(\''.$sub->nameS.'\',\''.$sub->ids.'\')">'.trim($sub->nameS).'</label></li>';
    					}//foreach
                        $ft_html.='</ul>';
                    }else $ft_html=''; //if not values erase the other tags too

                   $feat_html.=$ft_html;
				}//foreach
                $html_close='<div style="clear:both;"></div></div>';
                 //if there is even 1 value
                 if($val_exist)$html.=$htmlAp.$feat_html.$html_close;
                 else $html=$message;
		}//end if (count($vmf_feat)>0)

		else $html=$message;
		return $html;
	}

    function getVMmanufs($ids){
        $message='<p>&nbsp;'.JText::_('There are no Manufacturers for these Categories').'&nbsp;</p>';
      	$id=implode(',',$ids);

       	$db=JFactory::getDBO();
		$query="SELECT manufacturer_id,mf_name FROM #__vm_manufacturer WHERE manufacturer_id IN (SELECT manufacturer_id FROM #__vm_product_mf_xref WHERE product_id IN (SELECT product_id
		FROM #__vm_product_category_xref WHERE category_id IN(".$id."))) ORDER BY mf_name ASC";
		$db->setQuery($query);
		$vmManuf=$db->loadObjectList();

        //in case of include Manufacrurers------------
			if (count($vmManuf)>0){
			    $html='<div class="vmHeader"><div class="applybtn" onclick="dissapearMnf()"><span>'.JText::_('Apply').'</span></div></div>
                <div class="vmfWrapperInner">';

				$html.='<ul class="featureList" id="'.JText::_('Manufacturers').'">';//create a UL list for Manufacturer

				$html.='<li class="headerLi" id="manufHeader">
				<label class="headerIn"><input type="checkbox" class="headerIn" onclick="checkAll(\'manuf\',\'manuf\');">
				<strong class="headerIn">'.JText::_('Manufacturers').'</strong>
				</label></li>';//the header li

				foreach($vmManuf as $manuf){
					$html.='
						<li class="vmfsub"><label class="vmfsub"><input type="checkbox" class="manuf" id="'.$manuf->manufacturer_id.'_m" name="vm_mnuf[]" value="'.$manuf->manufacturer_id.'" title="'.$manuf->mf_name.'" onclick="setManufInput(\''.$manuf->mf_name.'\',\''.$manuf->manufacturer_id.'_m\')">'.trim($manuf->mf_name).'</label></li>';
				}//end foreach

               	$html.='</ul>';
                $html.='</div>';
			}//end if
          	else $html=$message;
		return $html;
    }

//catf sorting of results
function getSorting(){
  global $mainframe;
    $i=0;
    $sort_ar=array();
    $sort_labels=array();
    $sort1=$this->params->get('sorting1','total'); if($sort1){$sort_ar[]=$sort1; $sort_labels[]=JText::_('Best Match');}
    $sort2=$this->params->get('sorting2','prd.product_name'); if($sort2){$sort_ar[]=$sort2; $sort_labels[]=JText::_('Product Name'); }
    $sort3=$this->params->get('sorting3','prc.product_price'); if($sort3){$sort_ar[]=$sort3; $sort_labels[]=JText::_('Product Price');}
    $sort4=$this->params->get('sorting4','prd.cdate'); if($sort4){$sort_ar[]=$sort4; $sort_labels[]=JText::_('Latest Products');}
    $sort5=$this->params->get('sorting5','prd.product_special'); if($sort5){$sort_ar[]=$sort5; $sort_labels[]=JText::_('Featured Products');}
    $def_sort=$this->params->get('def-sorting');

	$sorting= $mainframe->getUserStateFromRequest('com_vmfiltering.sorting', 'sorting',$this->params->get('def-sorting'));

	$html='<form class="inputbox" action="index.php?'.$_SERVER['QUERY_STRING'].'" method="post" name="sortingForm">'.
	JText::_('Order By').':
	<select name="sorting" size="1" onchange="document.sortingForm.submit();">';

	foreach($sort_ar as $sort){
		$selected='';
		if($sort== $sorting) $selected=' selected="selected"';
		else if(!$sorting and $sort==$def_sort) $selected=' selected="selected"';// echo $def_sort.'-'.$sort;
		$html.='<option value="'.$sort.'"'.$selected.'>'.$sort_labels[$i].'</option>';
        $i++;
	}

	$html.='
	</select>
	</form>';

	return $html;
}

//if tax mode on shipping adress then calculate the user tax
 
function getShopItemid() {
		$itemId=NULL;
		if(empty($_REQUEST['Itemid'])) {
			$db=JFactory::getDBO();
			$query="SELECT id FROM #__menu WHERE link='index.php?option=com_virtuemart' AND published=1";
			$db->setQuery($query);
			if($db->query()){//CHECK FOR ERRORS
				$itemId = $db->loadResult();				
			}			
		}			
		else if( !empty( $_REQUEST['Itemid'] )) {
				$itemId = intval($_REQUEST['Itemid']);
			}			
		if (!isset($itemId) || empty($itemId)){
				$itemId = 1;
			}		
		return $itemId;
	}

function getUserTax($usr_id){
	$db=JFactory::getDBO();
	$query="SELECT country,state FROM #__vm_user_info WHERE user_id=".$usr_id;
	$db->setQuery($query);
	$results=$db->loadObject ();
	$shopperTaxRate=$this->getCountryTaxRate(@$results->country,@$results->state);
	return $shopperTaxRate;
	
	}
//----------------------do the search-----------------------//
function getProdsFromsPrices(){

	global $disc,$vat,$tax_mode;//from shopper froup info

	$vmCat=JRequest::getVar('vm_cat',array(),'get','array');
	$fr_price=JRequest::getVar('fr_price','','get');
	$to_price=JRequest::getVar('to_price','','get');
	$shopperGroupId=$this->shopperGroupId;
	$curWhere=NULL;
	$joins=NULL;
	$where_joins=NULL;
	$wherePr_id=NULL;

	$db=JFactory::getDBO();
	$currencies=array();

	$taxRates=array();//contains all the taxRates
	$prod_tax_ids=array();//contains all the products ids per taxRate

	//the price .if 1 of 2 is numeric values go
	   	if($fr_price && (is_numeric($fr_price)) || ($to_price && is_numeric ($to_price)))
		{	$prodIdsPrice=array();
			$cur=@$_SESSION['vendor_currency'];
			if(!$cur){
				global $cur;
				$this->getVendorInfo(1);
			}

			$whereSh=NULL;

			if($shopperGroupId!=$this->defaulShopGroup){
				$whereSh=" OR shopper_group_id=".$this->defaulShopGroup;
			}

			//get all the currencies of the products prices for the current shopper group and current cat
			$queryy="SELECT DISTINCT product_currency FROM #__vm_product_price,#__vm_product_category_xref WHERE shopper_group_id=".$shopperGroupId.$whereSh." AND #__vm_product_price.product_id=#__vm_product_category_xref.product_id AND #__vm_product_category_xref.category_id IN(".implode(',',$vmCat).")";
			$db->setQuery($queryy);
			$currencies=$db->loadResultArray();

			//define the price substracting discounts and taxes
			if($vat==1){

				if (is_numeric($fr_price)){
						if(abs($disc)>0)$fr_price=$fr_price/(1-($disc/100));
					}
					if (is_numeric($to_price)){
						if(abs($disc)>0)$to_price=$to_price/(1-($disc/100));
					}


				if ($tax_mode==0){
				//based on shipping mode
				//return products with 0 vat_id these do not taxed
					$taxRates['%']='-1';
					if($this->shopper_is_register and $this->usrTx>0){
					$taxRates['0']=0;
					if($this->usrTx>0) $taxRates['!0']=$this->usrTx;
					}
				}

				else if ($tax_mode==9 and $this->shopper_is_register and !$this->country_in_eu_vat_zone($this->shopper_country)){ //eu mode
						$taxRates['%']='-1';
						echo 0;
				}

				else if($tax_mode==1 ||($tax_mode==9 and (!$this->shopper_is_register) or ($this->shopper_is_register and $this->country_in_eu_vat_zone($this->shopper_country)))){
				 //based on Vend address
				//taxation


				$queryy="SELECT tax_rate_id,tax_rate FROM #__vm_tax_rate ";
				$db->setQuery($queryy);
				$prods_taxRates=$db->loadObjectList();
				$taxRates=array();//contains all the taxRates

				foreach($prods_taxRates as $taxrate){
					$taxRates[$taxrate->tax_rate_id]=$taxrate->tax_rate;
				}
				//the taxrate 0 is the vendor's country taxrate
				$this->getVendorInfo(1);
				global $vend_country,$vend_state;

				$taxRates["0"]=$taxRate=$this->getCountryTaxRate($vend_country,$vend_state);

				}//else if
			}// if vat==1
			else {//if not vat for that shopper group
				$taxRates['0']='';
			}

			$where=array();
			$whereOr=array();
			//print_r($taxRates);
			//build query
				//IF ONLY FROM_PRICE FIELD
				if((is_numeric ($fr_price)) and (!is_numeric($to_price)))
				{
					$fr_price=abs($fr_price);
					//print_r($prod_tax_ids);
					foreach($taxRates as $key=>$value){
						//check for 0 tax
						if($value>0) $fr_price_taxed=round($fr_price/(1+$value),2);
						else $fr_price_taxed=$fr_price;

						if((string)$key=="%"){//used to indicate everything but not 0 tax
							$taxRateQ="";
						}
						else if((string)$key=="!0"){//used to indicate everything but not 0 tax
							$taxRateQ="prd.product_tax_id!=".substr($key,1,1)." AND ";
						}
						else if((string)$key=="0" && $value=='') $taxRateQ='';//nothing
						else $taxRateQ="prd.product_tax_id=".$key." AND ";

						if(count($currencies)>0){
							foreach($currencies as $curnc){
								if($curnc !=$cur) {//in case of currency other than the vendor's
									$fr_price_conv=$this->convert($fr_price_taxed,$curnc,$cur);
									$whereOr[]="(".$taxRateQ."prc.product_price >=".$fr_price_conv." AND prc.product_currency='".trim($curnc)."')";
								}else $whereOr[]="(".$taxRateQ."prc.product_price >=".$fr_price_taxed." AND prc.product_currency='".trim($curnc)."')";
							}
						}
						else $whereOr[]="(".$taxRateQ."prc.product_price >=".$fr_price_taxed.")";$taxRateQ=NULL;
					}//foreach($prod_tax_ids as $p_ids_tax

				}//if there is only to value
				else if((!is_numeric ($fr_price)) and (is_numeric($to_price)))
				{	$to_price=abs($to_price);

					foreach($taxRates as $key=>$value){
						//check for 0 tax
						if($value>0) $to_price_taxed=round($to_price/(1+$value),2);
						else $to_price_taxed=$to_price;

						if((string)$key=="%"){//all tax_rate ids
							$taxRateQ="";
						}
						else if((string)$key=="!0"){//all but not 0 tax_rate ids
							$taxRateQ="prd.product_tax_id!=".substr($key,1,1)." AND ";
						}
					   	else if((string)$key=="0" && $value=='') $taxRateQ='';//nothing
						else $taxRateQ="prd.product_tax_id=".$key." AND ";

						if(count($currencies)>1){
							foreach($currencies as $curnc){
								if($curnc !=$cur) {//in case of currency other than the vendor's
									$to_price_conv=$this->convert($to_price_taxed,$curnc,$cur);
									$whereOr[]="(".$taxRateQ."prc.product_price <=".$to_price_conv." AND prc.product_currency='".trim($curnc)."')";
								}else $whereOr[]="(".$taxRateQ."prc.product_price <=".$to_price_taxed." AND prc.product_currency='".trim($curnc)."')";
							}
						}
						else $whereOr[]="(".$taxRateQ."prc.product_price <=".$to_price_taxed.")";
					}//foreach($prod_tax_ids as $p_ids_tax
				}
				//if there are -from- and -to- values
				else{
					$fr_price=abs($fr_price);
					$to_price=abs($to_price);
					
					foreach($taxRates as $key=>$value){
						//check for 0 tax
						if($value>0) {
							$fr_price_taxed=round($fr_price/(1+$taxRates[$key]),2);					
							$to_price_taxed=round($to_price/(1+$taxRates[$key]),2);
							}
						else {
							$fr_price_taxed=$fr_price;
							$to_price_taxed=$to_price;
							}
						if((string)$key=="%"){//all tax_rate ids
							$taxRateQ=""; 
						}
						else if((string)$key=="!0"){//all but not 0 tax_rate ids
							$taxRateQ="prd.product_tax_id!=".substr($key,1,1)." AND "; 
						}
					   	else if((string)$key=="0" && $value=='') $taxRateQ='';//nothing
						else $taxRateQ="prd.product_tax_id=".$key." AND ";//certain tax
							
							if(count($currencies)>0){
								foreach($currencies as $curnc){
									if($curnc !=$cur) {//in case of currency other than the vendor's
										$fr_price_conv=$this->convert($fr_price_taxed,$curnc,$cur);
										$to_price_conv=$this->convert($to_price_taxed,$curnc,$cur);
										$whereOr[]="(".$taxRateQ."prc.product_price BETWEEN ".$fr_price_conv." AND ".$to_price_conv." AND prc.product_currency='".trim($curnc)."')";

									}else $whereOr[]="(".$taxRateQ."prc.product_price BETWEEN ".$fr_price_taxed." AND ".$to_price_taxed." AND prc.product_currency='".trim($curnc)."')";
								}
							}
							else $whereOr[]="(".$taxRateQ."prc.product_price BETWEEN ".$fr_price_taxed." AND ".$to_price_taxed.")";
						}//foreach $prod_tax_ids
					}

				$whereEoR='('.implode(' OR ',$whereOr).')';
				$this->whereExpr[]=$whereEoR;

		}//end else			
	return;
}//end getProdsFromPrices

//set the necessary vars for the query for price search or price ordering
function setPriceQ_settings(){
    $whereShp='';
	$this->joinExpr[]="#__vm_product_price AS prc ON prc.product_id=prd.product_id";
	$shopperGroupId=$this->shopperGroupId;
	if($shopperGroupId!=$this->defaulShopGroup){
		$whereShp=" OR (prc.shopper_group_id=".$this->defaulShopGroup." AND prc.product_id NOT IN(SELECT product_id FROM #__vm_product_price WHERE shopper_group_id=".$shopperGroupId."))";
	}
	$whereShop="(prc.shopper_group_id=".$shopperGroupId.$whereShp.")";

	$this->whereExpr[]=$whereShop;
	$this->whereExpr[]="prc.price_quantity_start<=1";
}


/*------------------do the search----------------*/
function search(){

	global $disc,$vat,$tax_mode,$mainframe;//from shopper froup info
    $orderBy=NULL;
	$where=NULL;
    $whereExp='';
    $joins=''; 
    $having_count='';
	$vmCat=JRequest::getVar('vm_cat',array(),'get','array');
	$feat_fl=JRequest::getVar('feat_fl',array(),'get','array');
	$vm_manufact=JRequest::getVar('vm_mnuf',array(),'get','array');
	$shopperGroupId=@$_SESSION['auth']['shopper_group_id'];
    $extra_field='';
    $groupBy='';

	$db=JFactory::getDBO();
    $counter_vmManuf=count($vm_manufact);
						
	$queries=array();
	$fr_price=JRequest::getVar('fr_price','','get');
	$to_price=JRequest::getVar('to_price','','get');
	
	if($fr_price && (is_numeric($fr_price)) || ($to_price && is_numeric ($to_price))){
		$queryPrice=$this->getProdsFromsPrices();
		$pricesSelected=0;
		if($queryPrice){
			$queries[]=$queryPrice;
			$pricesSelected=1;
		}				
	}
		//in case of manufacturers
		//there are manufacturers selected
		if ($counter_vmManuf>0)
		{    $vm_mnf=array();
             foreach($vm_manufact as $vm_m){
               if(is_numeric($vm_m) && $vm_m>0)$vm_mnf[]=$vm_m;
             }
			$whereManf=implode(',',$vm_mnf);
            if($whereManf){$whereManuf="manf.manufacturer_id IN (".$whereManf.")";
    			$this->joinExpr[]="#__vm_product_mf_xref AS manf ON manf.product_id=prd.product_id";
    			$this->whereExpr[]=$whereManuf;
            }
		}

		//in case of features
		if(count($feat_fl>0)){
		  $feats=array();
		  //echo 'yea';
            foreach($feat_fl as $ff){
              $feat_name="feat_".$ff;
              $feat=JRequest::getVar($feat_name,array(),'get','array');
              if(count($feat)>1 || (count($feat)==1 && $feat[0]!=0)){
                if($this->params->get('match_type',1)==1){//absolute matching
                $this->joinExpr[]="#__vmfprodsubcategory AS feat_".$ff." ON feat_".$ff.".product_id=prd.product_id";
                $this->whereExpr[]="feat_".$ff.".ids IN(".implode(',',$feat).")";
                }
                else{//relative matching
                    $feats=array_merge($feats,$feat);

                }//else
              }//if(count($feat
            }//foreach($feat_fl

             if($this->params->get('match_type',1)==0 and count($feats)>0){//relative matching
                $this->joinExpr[]="#__vmfprodsubcategory AS feat ON feat.product_id=prd.product_id";
                $this->whereExpr[]="feat.ids IN(".implode(',',$feats).")";
             }

		}//	if(count($feat_fl>0
				
		//category
		if(count($vmCat)>0){
			$whereExprcat=array(); //array that stores the categories query
			$whereExprcat_ex="cat.category_id IN (".implode(',',$vmCat).")";
			$whereExprcat_ex="(".$whereExprcat_ex.")";
			$this->whereExpr[]=$whereExprcat_ex;
			$this->joinExpr[]="#__vm_product_category_xref AS cat ON cat.product_id=prd.product_id";
		}
				
		
		//pagination settings
        $limit=$mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart=JRequest::getVar('limitstart', 0, '', 'int');
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $this->limit=$limit;
        $this->limitstart=$limitstart;

        //sorting
        $sort= $mainframe->getUserStateFromRequest('com_vmfiltering.sorting', 'sorting',$this->params->get('def-sorting'));
    	if($sort && ($sort=='total' || $sort=='prd.cdate' || $sort=='prd.product_name' || $sort=='prc.product_price' || $sort=='prd.product_special')){
            if($sort=='prd.cdate' || $sort=='prd.product_special' || $sort=='total')  $orderBy=$orderBy=" ORDER BY ".$sort." DESC";
            else $orderBy=" ORDER BY ".$sort." ASC";

            if($sort=='total') {
              $extra_field=',COUNT(prd.product_id) AS total';
              $groupBy=" GROUP BY prd.product_id";
              }
       	}

        if($sort=='prc.product_price' || ($fr_price && (is_numeric($fr_price)) || ($to_price && is_numeric ($to_price))))$this->setPriceQ_settings();



        //prepare the query vars
		if (!empty($this->joinExpr)){
			$joins=implode(" INNER JOIN ",$this->joinExpr);
			$joins=" INNER JOIN ".$joins;
		}

	    $this->whereExpr[]='prd.product_publish=\'Y\'';
        $this->whereExpr[]='prd.product_parent_id=0';

		$whereEx=implode(" AND ",$this->whereExpr);
		$whereExp=" WHERE ".$whereEx;

		$fields="prd.product_name,prd.product_parent_id, prd.product_s_desc, prd.product_thumb_image, prd.product_full_image, prd.product_tax_id, prd.product_discount_id, prd.vendor_id, prd.product_weight, prd.product_in_stock, prd.attribute";
		
		//$this->orderExpr;
		$queryMain="SELECT SQL_CALC_FOUND_ROWS DISTINCT prd.product_id,".$fields.$extra_field." FROM #__vm_product AS prd".$joins.$whereExp.$groupBy.$orderBy;
		$db->setQuery($queryMain,$this->limitstart,$this->limit);
		//print_r($queryMain);

		if(!$db->query()){//CHECK FOR ERRORS
			$this->setError($db->getErrorMsg());
		}			
		$results=$db->loadObjectList();
						
		if(isset($this->limit) and ($this->limit!=0)){
			//$db->setQuery('SELECT FOUND_ROWS();');  //no reloading the query! Just asking for total without limit

			$this->total=$this->_getListCount($queryMain); //$db->loadResult();
		}

		return $results;
}


function setShopperGroup_info(){
	global $disc,$vat;
	$this->shopperGroupId=@$_SESSION['auth']['shopper_group_id'];
	$this->shopper_is_register=@$_SESSION['auth']['is_registered_customer'];
	$this->shopper_country=@$_SESSION['auth']['country'];
	$db=JFactory::getDBO();		
	
	
	//select the default	
	$queryy="SELECT shopper_group_id, shopper_group_discount, show_price_including_tax FROM #__vm_shopper_group WHERE #__vm_shopper_group.default=1";	 
	$db->setQuery($queryy);
	if(!$db->query()){//CHECK FOR ERRORS
		$this->setError($db->getErrorMsg());
	}
	$default_shopper_gr=$db->loadObject();
	$this->defaulShopGroup=$default_shopper_gr->shopper_group_id;	
		
	
	//if there is shopper group in the session
	if($this->shopperGroupId){
	//select shopper group properties
		$query='SELECT shopper_group_discount,show_price_including_tax FROM #__vm_shopper_group WHERE shopper_group_id='.$this->shopperGroupId;		 
		$db->setQuery($query);
		if(!$db->query()){//CHECK FOR ERRORS
			$this->setError($db->getErrorMsg());
		}	
				
		$shopGr=$db->loadObject();		
		$disc=$shopGr->shopper_group_discount;		
		//indicates the show tax for the group
		$vat=$shopGr->show_price_including_tax;
	}
	else {
		$this->shopperGroupId=$this->defaulShopGroup;
		$disc=$default_shopper_gr->shopper_group_discount;
		$vat=$default_shopper_gr->show_price_including_tax;
	}	
}



//---------------------------------get prices for each product--------------------------------//
function getProductPrice($id, $tax_id,$disc_id,$vend_id,$weight){
	$db=JFactory::getDBO();
	
	global $show_prices,$tax_virtual,$tax_mode,$payment_discount_before;//vm params
	global $disc,$vat;//shoppr infos
	global $vendor,$style,$cur,$string,$vend_country,$vend_state; //vendor infos
	
	
	
	if($show_prices==1){
		//the price depends on 
		//product price of a shopper group of the user
		//product vat
		//product discount
		//procuct currency
		
		$priceValDisc=NULL;
		$priceVal=NULL;
		$endDate=NULL;
		$shopper=NULL;		
	
		if(isset($vend_id) && $vend_id!=0){
			$this->getVendorInfo($vend_id);
		}

		$shopperGroupId=$this->shopperGroupId;
		$price=$this->getShopperGrPrice($disc,$shopperGroupId,$id,$cur);
		if ($price==0|| empty($price)){
			$msg=JText::_('No price');
			return $msg;
		} 
		$priceVal=$price;			
		
		//--------------------------tax---------------------------------------//
			//the tax counting depents on vm parameters
		if($vat!=0 and ($tax_virtual==1 || $weight>0)){
			$taxRate=$this->getTaxRate($tax_mode,$tax_id);
			$priceVal=$price +($price*$taxRate);
		}
			
		//-----------------------------discount--------------------------//
		if ($payment_discount_before==0){//if PAYMENT_DISCOUNT_AFTER		
			if($disc_id>0){	
				$priceValDisc=$this->getDiscountedPr($priceVal,$disc_id,'');				
			}//end discount		
		}//end if PAYMENT_DISCOUNT_AFTER
		
		
		
		else {//if PAYMENT DISCOUNT BEFORE
			if($disc_id>0){	
			$priceValDisc=$this->getDiscountedPr($price,$disc_id);
				if($vat!=0 and ($tax_virtual==1 || $weight>0)){
					$taxRate=$this->getTaxRate($tax_mode,$tax_id);
					$priceValDisc=$priceValDisc +($priceValDisc*$taxRate);
				}	
			}		
	
		}//end else PAYMENT_DISCOUNT_BEFORE
		
	//---------------convert to right currency----------------//		
		$priceVal=number_format(round($priceVal,2),2);//rounding the price
		 if ($string[5]==0){
				$priceVal=$priceVal.$string[1];		
				}		
		else if ($string[5]==1){
			$priceVal=$priceVal.' '.$string[1];		
				}				
		else if ($string[5]==2){
			$priceVal=$string[1].$priceVal;		
			}		
		else if ($string[5]==3){
			$priceVal=$string[1].' '.$priceVal;
					}
		
	//if there is  discount		
		if($priceValDisc>0){		
			$priceValDisc=number_format(round($priceValDisc,2),2);//rounding the discount price				
			//currency symbol positioning
			if ($string[5]==0){
				$priceValDisc=$priceValDisc.$string[1];
				}		
			else if ($string[5]==1){
				$priceValDisc=$priceValDisc.' '.$string[1];		
				}
			else if ($string[5]==2){
				$priceValDisc=$string[1].$priceValDisc;		
			}
			else if ($string[5]==3){
				$priceValDisc=$string[1].' '.$priceValDisc;		
			}
			
			//formating
			$prodPrice='<span class="product-Old-Price">'.$priceVal.'</span><br>
	<span class="productPrice">'.$priceValDisc.'</span>';
			return $prodPrice;
		}		
		$prodPrice='<span class="productPrice">'.$priceVal.'</span>';		
		return $prodPrice;		
		}//end _SHOW_PRICES
			
	return;
}

	function getTaxRate($tax_mode,$tax_id=NULL){//gets the tax
		global $vend_country,$vend_state;
		
		$shopper_is_register=$this->shopper_is_register;
		$shopper_country=$this->shopper_country;
		$taxRate=NULL;
		
		//based on shipping address
			if(($tax_mode==0) and $shopper_is_register and $tax_id!=0){
				$taxRate=$this->usrTx;				
			}
			//based on vendor address
			else if(($tax_mode==1)){
				$taxRate=$this->getVat($tax_id);
				if($taxRate<=0) 
				{					
					$taxRate=$this->getCountryTaxRate($vend_country,$vend_state);
				}							
			}			
								
			//eu tax vm file:admin/classes/ps.product.php - function get_product_taxrate
			else if ($tax_mode==9 or $tax_mode==17749){
				if ($shopper_is_register and $this->country_in_eu_vat_zone($shopper_country)){
					$taxRate=$this->getVat($tax_id);
					if($taxRate<=0) 
					{					
						$taxRate=$this->getCountryTaxRate($vend_country,$vend_state);//gets the vendor tax rate
					}
				}
				else if ($shopper_is_register and !$this->country_in_eu_vat_zone($shopper_country)){
					$taxRate=0;
				}
				else {
					$taxRate=$this->getVat($tax_id);
					if($taxRate<=0) 
					{					
						$taxRate=$this->getCountryTaxRate($vend_country,$vend_state);//gets the vendor tax rate
					}
				}		
			}		
		return $taxRate;
	}
	
	
	function getCountryTaxRate($country,$state=NULL){
		$db=JFactory::getDBO();
		
		$state=trim($state);
		if(isset($state) and($state!='' || $state!='-')){
			$where=" AND tax_state='".$state."'";		
		}		
		 $queryy="SELECT tax_rate FROM #__vm_tax_rate WHERE tax_country='".$country."'".$where;
		 $db->setQuery($queryy);
		 if(!$db->query()){//CHECK FOR ERRORS
			$this->setError($db->getErrorMsg());
		}		
		 $taxRate=$db->loadResult();
		 return $taxRate;	
	}
	
	function getVendorInfo($vend_id){
		global $vendor,$style,$cur,$string,$vend_country,$vend_state;		
		$db=JFactory::getDBO();
		$query='SELECT vendor_currency_display_style AS style,vendor_currency  AS cur,vendor_country,vendor_state FROM #__vm_vendor WHERE vendor_id='.$vend_id;
		$db->setQuery($query);
		if(!$db->query()){//CHECK FOR ERRORS
			$this->setError($db->getErrorMsg());
		}
		$vendor=$db->loadObject();
		$style=$vendor->style; //get the currency display style
		$cur=$vendor->cur;
		//print_r( $_SESSION);
		$vend_country=$vendor->vendor_country;
		$vend_state=$vendor->vendor_state;		
		$string=explode('|',$style);		
	}
	
	
	
	//------------------------shopper group price----------------------------------// 	
	function getShopperGrPrice($disc,$shopperGroupId,$id,$Vendcur){	
		$db=JFactory::getDBO();		
					
		//select price
		if (isset($shopperGroupId) || $shopperGroupId!=0){
		$shopper=' AND shopper_group_id='.$shopperGroupId;
		}
		
		$query='SELECT product_price ,product_currency FROM #__vm_product_price WHERE product_id='.$id.$shopper;
		$db->setQuery($query);
		$ob=$db->loadObject();
		
		$price=@$ob->product_price;
		$curr=@$ob->product_currency;
		$price-=$price*($disc/100);
				
		//IF THERE IS NO PRICE for the current shopping group check 
		//if there is a default group for this vendor which has price return the price of the default group

		if ($price==NULL){
			$query='SELECT shopper_group_id FROM #__vm_shopper_group WHERE #__vm_shopper_group.default=1 AND vendor_id =(SELECT vendor_id FROM #__vm_shopper_group WHERE shopper_group_id='.$shopperGroupId.')';
			
			$db->setQuery($query);
			$defShopperGr=$db->loadObject();			
				
			//now check for price
			$query='SELECT product_price ,product_currency FROM #__vm_product_price WHERE product_id='.$id.' AND shopper_group_id= '.$defShopperGr->shopper_group_id;	
			$db->setQuery($query);
			$pricee=$db->loadObject();
			
			//if there is no price even for the default group
			if (!isset($pricee) || $pricee->product_price==''){
			$price=JText::_('There is no Price');
			}			
			//if there is reduce the discount of the current shoppper group
			else{	
			$curr=$pricee->product_currency;
			$price=$pricee->product_price;
			$price-=$price*($disc/100);
			}
			
		}
	
		//ends shopper group pricing
		if(trim($Vendcur)!=trim($curr) and ($price>0)){
		$price=$this->convert($price,$Vendcur,$curr);}	
			
		return $price;
	}
	
	
	//------------------------get DiscountedPrice-----------------//
	function getDiscountedPr($priceVal,$disc_id){
		$db=JFactory::getDBO();
		//checking for expiration date	
		$Date=' AND (end_date >='.date("U").' OR end_date=0) AND (start_date  <='.date("U").' OR end_date=0)';	
		
		$query='SELECT * FROM #__vm_product_discount WHERE discount_id='.$disc_id.$Date ;
		$db->setQuery($query);
		$discount=$db->loadObject();		
		//returns null if no valid discount found
		
		if(isset($discount)){
			if($discount->is_percent==1){
				$priceValDisc=$priceVal- ($priceVal*($discount->amount/100));
			}
			else {$priceValDisc=$priceVal-$discount->amount;}
			
			return $priceValDisc;
		}
		return 0;
	}
		
	//------------------------------get tax---------------------//
	
	function getVat($tax_id){
		
		$db=JFactory::getDBO();
		$query='SELECT tax_rate FROM #__vm_tax_rate WHERE tax_rate_id='.$tax_id;
		$db->setQuery($query);
		$taxRate=$db->loadResult();	
		
		return $taxRate;
	}
	
	function country_in_eu_vat_zone ($country) {//check if it is eu country
		$eu_countries = array ('AUT', 'BGR', 'BEL', 'CYP', 'CZE', 'DEU', 'DNK', 'ESP', 'EST', 
								'FIN', 'FRA', 'FXX', 'GBR', 'GRC', 'HUN', 'IRL', 'ITA', 'LVA', 'LTU', 
								'LUX', 'MLT', 'NLD', 'POL', 'PRT', 'ROM', 'SVK', 'SVN', 'SWE');
		return in_array ($country, $eu_countries);
	
	}
	//-------------------Convert Currency function-----------------------------//
	
	function convert( $amountA, $currA='', $currB='' ) {
		
		$archive = true;
		$last_updated = '';	
		$document_address = 'http://www.ecb.int/stats/eurofxref/eurofxref-daily.xml';	
		$info_address = 'http://www.ecb.int/stats/eurofxref/';
		$supplier = 'European Central Bank';
		$cachepath=JPATH_BASE.'/cache';
		$absolute_path=JPATH_BASE;
		
		if( $currA == $currB ) {		
			return $amountA;
		}
		
			setlocale(LC_TIME, "en-GB");
			$now = time() + 3600; // Time in ECB (Germany) is GMT + 1 hour (3600 seconds)
			if (date("I")) {
				$now += 3600; // Adjust for daylight saving time
			}
			$weekday_now_local = gmdate('w', $now); // week day, important: week starts with sunday (= 0) !!
			$date_now_local = gmdate('Ymd', $now);
			$time_now_local = gmdate('Hi', $now);
			$time_ecb_update = '1415';
			
			if( is_writable($cachepath) ) {
				$store_path = $cachepath;								
			}
			else {
				$store_path = $absolute_path."/media";
			}
			  
			$archivefile_name = $store_path.'/daily.xml';
			$ecb_filename = $document_address;
			$val = '';
			
			if(file_exists($archivefile_name) && filesize( $archivefile_name ) > 0 ) {
			  	// timestamp for the Filename
			  	$file_datestamp = date('Ymd', filemtime($archivefile_name)); 
			  	
		    	// check if today is a weekday - no updates on weekends// VM BUG does not takes the German (ecb) date 
		    	if( date( 'w' ) > 0 && date( 'w' ) < 6 
		    		// compare filedate and actual date
		    		&& $file_datestamp != $date_now_local // BUG compares the file datestamp which uses the system's time with the german time
		    		// if localtime is greater then ecb-update-time go on to update and write files
		    		&& $time_now_local > $time_ecb_update) {
		    		$curr_filename = $ecb_filename;	
		    	}
		    	else {
				  	$curr_filename = $archivefile_name;
		    		$last_updated = $file_datestamp;
				  	$archive = false;	
		    	}
				
			}
			else {
				$curr_filename = $ecb_filename;
			}			  
			  
			if( !is_writable( $store_path )) {
			  $archive = false;
			  echo( "The file $archivefile_name can't be created. The directory $store_path is not writable" );
			}
			if( $curr_filename == $ecb_filename ) {
			// Fetch the file from the internet
				
				$contents = $this->handleCommun( $curr_filename );
				
				$last_updated = date('Ymd');
			}
			else {
				$contents = @file_get_contents( $curr_filename );
			}			
			
			if( $contents ) {
				// if archivefile does not exist
				if( $archive ) {
					// now write new file
					file_put_contents( $archivefile_name, $contents );
				}
		
				$contents = str_replace ("<Cube currency='USD'", " <Cube currency='EUR' rate='1'/> <Cube currency='USD'", $contents);
							
				/* XML Parsing */
				require_once(JPATH_BASE.'/includes/domit/xml_domit_lite_include.php' );
				$xmlDoc =new DOMIT_Lite_Document();
				if( !$xmlDoc->parseXML( $contents, false, true ) ) {
					echo( 'Failed to parse the Currency Converter XML document.');
					$GLOBALS['product_currency'] = $vendor_currency;
					return $amountA;
				}
				
				$currency_list = $xmlDoc->getElementsByTagName( "Cube" );
				// Loop through the Currency List
				for ($i = 0; $i < $currency_list->getLength(); $i++) {
				
					$currNode =& $currency_list->item($i);
					
					$currency[$currNode->getAttribute("currency")] = $currNode->getAttribute("rate");
					unset( $currNode );
				}
				$GLOBALS['converter_array'] = $currency;
			} 
			
			else {
				$GLOBALS['converter_array'] = -1;
				echo( 'Failed to retrieve the Currency Converter XML document.');
				$GLOBALS['product_currency'] = $vendor_currency;
				return $amountA;
			}		
		
		$valA = isset( $GLOBALS['converter_array'][$currA] ) ? $GLOBALS['converter_array'][$currA] : 1;
		$valB = isset( $GLOBALS['converter_array'][$currB] ) ? $GLOBALS['converter_array'][$currB] : 1;
		
		$val = $amountA * $valA / $valB;		
		return $val;			
	}//convert function
	
	
	function handleCommun( $url, $fileToSaveData=null ) {		
		$fp=fopen($url,'rb');		
		if(!$fp){
			//error tell us
			
			return false;
			}		
			$data = "";
			while (!feof($fp)) {
				$data .= @fgets ($fp, 4096);
			}
			fclose( $fp );		
		if ( trim($data) == '' ) {
				$echo('An error occured while communicating with the server . It didn\'t reply (correctly). Please try again later, thank you.' );
				return false;
			}
			$result = trim( $data );		
		if( is_resource($fileToSaveData )) {
				fwrite($fileToSaveData, $result );
				return true;
			} else {
				return $result;
	}
}
 //----------------Add to cart functionalities-----------------------//

      function get_quantity_options( $product_id ) {
        $db=JFactory::getDBO();
        $query="SELECT quantity_options FROM #__vm_product WHERE product_id=".$product_id;
        $db->setQuery($query);
        $quantity_options_string=$db->loadResult();

    	$quantity_options = array('quantity_start' => 0, 'quantity_end' => 0, 'quantity_step' => 1 );


    	$fields = explode(',', $quantity_options_string );
    	if( !empty( $fields )&& sizeof($fields) > 1 ) {
    		$quantity_options['quantity_box'] = $fields[0];
    		$quantity_options['display_type'] = $fields[0];
    		$quantity_options['quantity_start'] = $fields[1];
    		$quantity_options['quantity_end'] = $fields[2];
    		$quantity_options['quantity_step'] = $fields[3];
    	}
        unset($db);
    	return $quantity_options;
    }

	/**
	 * Creates the Quantity Input Boxes/Radio Buttons/Lists for Products
	 *
	 * @param int $product_id The Parent Product ID
	 * @param int $prod_id The actual Product ID
	 * @param string $child
	 * @param string $use_parent
	 * @return string
	 */
	function show_quantity_box( $product_id, $prod_id,$product_in_stock, $child = false, $use_parent = 'N' ) {
	   global $check_stock;

		if( $child == 'Y' ) {
			//We have a child list so get the current quantity;
			$quantity = 0 ;
			for( $i = 0 ; $i < $_SESSION["cart"]["idx"] ; $i ++ ) {
				if( $_SESSION['cart'][$i]["product_id"] == $prod_id ) {
					$quantity = $_SESSION['cart'][$i]["quantity"] ;
				}
			}
		} else {
			$quantity = JRequest::getInt( 'quantity', 1 ) ;
		}
		// Detremine which style to use
		if( $use_parent == 'Y' && !empty($product_id)) {
			$id = $product_id ;
		} else {
			$id = $prod_id ;
		}
		//Get style to use

		$quantity_options = $this->get_quantity_options( $id ) ;
		extract( $quantity_options ) ;

		//Start output of quantity
		//Check for incompatabilities and reset to normal
		if( $this->check_stock == 1 && ! $product_in_stock ) {
			$display_type = 'hide' ;
		}
		if( empty( $display_type ) || (@$display_type == "hide" && $child == 'Y') || (@$display_type == "radio" && $child == 'YM') || (@$display_type == "radio" && ! $child) ) {
			$display_type = "none" ;
		}
		unset( $quantity_options['display_type'] ) ;

        //html production
       extract( $quantity_options );

      $html = '';
      if(!$child && $display_type != 'hide') {
      	$html = '<label for="quantity'.$prod_id.'" class="quantity_box">'.JText::_("Quantity").':&nbsp;</label>';
      }
      switch($display_type) {
      	case "radio" : //Radio Box
      		$html .= '<input type="hidden" id="quantity'.$prod_id.'" name="quantity[]" value="'.$quantity.'" />';
      		$html .= '<input type="radio" class="quantitycheckbox" id="selItem'.$prod_id.'" name="selItem" value="0" ';
      		if ($quantity > 0 ) {
      			$html .= 'checked="checked" ';
      		}
      		$html .= 'onclick="alterQuantity(this.form)" />';
      		break;
      	case "hide" : // Hide box - but set quantity to 1!
      		$html .= '<input type="hidden" id="quantity'.$prod_id.'" name="quantity[]" value="1" />';
      		break;
      	case "check" :
      		$html .= '<input type="hidden" id="quantity'.$prod_id.'" name="quantity[]" value="'.$quantity.'" style="vertical-align: middle;"/>
      		<input type="checkbox" class="quantitycheckbox" id ="selItem'.$id.'" name="check[]" ';
      		if ($quantity > 0 ) {
      			$html .= 'checked="checked"';
      		}
      		$html .= ' value="1" onclick="javascript: if(this.checked==true) document.getElementById(\'quantity'.$prod_id.'\').value = 1; else {document.getElementById(\'quantity'.$prod_id.'\').value=0;} "/> ';
      		break;
      	case "drop" :
      		$code = '<select class="inputboxquantity" id="quantity'.$prod_id.'" name="quantity[]">';
      		for($i=$quantity_start;$i<$quantity_end+1;$i += $quantity_step) {
      			$code .= '  <option value="'.$i.'"';
      			if ($i == $quantity) {
      				$code .= ' selected="selected"';
      			}
      			$code .= '>'.$i."</option>\n";
      		}
      		$code .= "</select>\n";
      		$html .= $code;
      		break;
      	case "none" :
      	default:
      		$html .= '<input type="text" class="inputboxquantity" size="4" id="quantity'.$prod_id.'" name="quantity[]" value="'.$quantity.'" />
      		<input type="button" class="quantity_box_button quantity_box_button_up" onclick="var qty_el = document.getElementById(\'quantity'.$prod_id.'\'); var qty = qty_el.value; if( !isNaN( qty )) qty_el.value++;return false;" />
      		<input type="button" class="quantity_box_button quantity_box_button_down" onclick="var qty_el = document.getElementById(\'quantity'.$prod_id.'\'); var qty = qty_el.value; if( !isNaN( qty ) && qty > 0 ) qty_el.value--;return false;" />
      		';
      		break;
      }
      return $html ;
	}
function getParentImage($par_id){
  $db=JFactory::getDBO();
  $q='SELECT product_thumb_image FROM #__vm_product WHERE product_id='.$par_id;
  $db->setQuery($q);
  $res=$db->loadResult();
  return $res;
}

 function hasChild($p_id){
        $db=JFactory::getDBO();
        $query='SELECT product_id FROM #__vm_product WHERE product_parent_id='.$p_id;
        $db->setQuery($query);
        $result=$db->loadResult();
        return $result;
    }

}//class